package sun.text.normalizer;

import java.util.HashMap;

public final class VersionInfo
{
    private int m_version_;
    private static final HashMap<Integer, Object> MAP_;
    private static final String INVALID_VERSION_NUMBER_ = "Invalid version number: Version number may be negative or greater than 255";
    
    public static VersionInfo getInstance(String str) {
        int length = str.length();
        int[] array = { 0, 0, 0, 0 };
        int n;
        int index;
        for (n = 0, index = 0; n < 4 && index < length; ++index) {
            int char1 = str.charAt(index);
            if (char1 == '.') {
                ++n;
            }
            else {
                int n2 = (char)(char1 - 48);
                if (n2 < '\0' || n2 > '\t') {
                    throw new IllegalArgumentException("Invalid version number: Version number may be negative or greater than 255");
                }
                int n3 = n;
                array[n3] *= 10;
                int n4 = n;
                array[n4] += n2;
            }
        }
        if (index != length) {
            throw new IllegalArgumentException("Invalid version number: String '" + str + "' exceeds version format");
        }
        int i = 0;
        while (i < 4) {
            if (array[i] < 0 || array[i] > 255) {
                throw new IllegalArgumentException("Invalid version number: Version number may be negative or greater than 255");
            }
            ++i;
        }
        return getInstance(array[0], array[1], array[2], array[3]);
    }
    
    public static VersionInfo getInstance(int n, int n2, int n3, int n4) {
        if (n < 0 || n > 255 || n2 < 0 || n2 > 255 || n3 < 0 || n3 > 255 || n4 < 0 || n4 > 255) {
            throw new IllegalArgumentException("Invalid version number: Version number may be negative or greater than 255");
        }
        int int1 = getInt(n, n2, n3, n4);
        Integer value = Integer.valueOf(int1);
        Object value2 = VersionInfo.MAP_.get(value);
        if (value2 == null) {
            value2 = new VersionInfo(int1);
            VersionInfo.MAP_.put(value, value2);
        }
        return (VersionInfo)value2;
    }
    
    public int compareTo(VersionInfo versionInfo) {
        return this.m_version_ - versionInfo.m_version_;
    }
    
    private VersionInfo(int version_) {
        this.m_version_ = version_;
    }
    
    private static int getInt(int n, int n2, int n3, int n4) {
        return n << 24 | n2 << 16 | n3 << 8 | n4;
    }
    
    static {
        MAP_ = new HashMap();
    }
}
